#include "REALS.h"
#include "REALLIB.h"
#include <time.h>
#include <stdio.h>

REAL maxapprox (long prec, const REAL& x, const REAL& y){
   if ( positive(x-y,prec) ) return x;
   else return y;
};

REAL max (const REAL& x, const REAL& y){
   return limit(maxapprox,x,y);
};

void compute() {

clock_t time1, time2;
double timediff;

rprintf("Small test program testing functions...\n");

const REAL x1=0.5;
const long calc_accu = -50;
REAL result, result2, result3, result4, result5, result6, result7;

/*
time1 = clock();

result = sin(x1);

rprintf("Result of sin of\n");
rwrite(x1,-30,20);
rprintf("\n\nis:\n\n");
rwrite(result,calc_accu,100);
rprintf("\n\n");

time2 = clock();
timediff = (time2 - time1)/(CLOCKS_PER_SEC / (double) 1000.0);
printf("Calculation took %f.\n\n", timediff);


time1 = clock();

result2 = cos(x1);

rprintf("Result of cos of\n");
rwrite(x1,-30,30);
rprintf("\n\nis:\n\n");
rwrite(result2,calc_accu,100);
rprintf("\n\n");

time2 = clock();
timediff = (time2 - time1)/(CLOCKS_PER_SEC / (double) 1000.0);
printf("Calculation took %f.\n\n", timediff);

*/

time1 = clock();

result3 = exp(x1);

rprintf("Result of exp of\n");
rwrite(x1,-30,20);
rprintf("\n\nis:\n\n");
rwrite(result3,calc_accu,100);
rprintf("\n\n");

time2 = clock();
timediff = (time2 - time1)/(CLOCKS_PER_SEC / (double) 1000.0);
printf("Calculation took %f.\n\n", timediff);

/*

time1 = clock();

result4 = tan(x1);

rprintf("Result of tan of\n");
rwrite(x1,-30,20);
rprintf("\n\nis:\n\n");
rwrite(result4,calc_accu,100);
rprintf("\n\n");

time2 = clock();
timediff = (time2 - time1)/(CLOCKS_PER_SEC / (double) 1000.0);
printf("Calculation took %f.\n\n", timediff);



time1 = clock();

result5 = tanh(x1);

rprintf("Result of tanh of\n");
rwrite(x1,-30,20);
rprintf("\n\nis:\n\n");
rwrite(result5,calc_accu,100);
rprintf("\n\n");

time2 = clock();
timediff = (time2 - time1)/(CLOCKS_PER_SEC / (double) 1000.0);
printf("Calculation took %f.\n\n", timediff);


time1 = clock();

result6 = atan(x1);

rprintf("Result of arctan of\n");
rwrite(x1,-30,30);
rprintf("\n\nis:\n\n");
rwrite(result6,calc_accu,100);
rprintf("\n\n");

time2 = clock();
timediff = (time2 - time1)/(CLOCKS_PER_SEC / (double) 1000.0);
printf("Calculation took %f.\n\n", timediff);


time1 = clock();

result7 = atanh(x1);

rprintf("Result of arctanh of\n");
rwrite(x1,-30,30);
rprintf("\n\nis:\n\n");
rwrite(result7,calc_accu,100);
rprintf("\n\n");

time2 = clock();
timediff = (time2 - time1)/(CLOCKS_PER_SEC / (double) 1000.0);
printf("Calculation took %f.\n\n", timediff);
*/

}

int main (int argc,char **argv)
{
iRRAM_initialize(argc,argv);
iRRAM_exec(compute);
}
